<?php
/**
*
* @package Simply Move Topics
* @copyright (c) 2016 Bruninoit
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/
namespace bruninoit\smt\event;
/**
* @ignore
*/
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
/**
* Event listener
*/
class smt implements EventSubscriberInterface
{
	static public function getSubscribedEvents()
	{
		return array(
			'core.user_setup'						=> 'load_language_on_setup',
			'core.viewtopic_get_post_data'					=> 'viewtopic_actions',
			'core.viewtopic_modify_post_row'					=> 'post',
			//'core.permissions'						=> 'permission_wvtt',

//acp
          'core.acp_manage_forums_request_data' => 'acp_data',
          'core.acp_manage_forums_initialise_data' => 'acp_init',
          'core.acp_manage_forums_display_form' => 'acp_form',

			);
	}
	/* @var \phpbb\template\template */
	protected $template;
	/** @var \phpbb\db\driver\driver_interface */
	protected $db;
	/** @var \phpbb\user */
	protected $user;
	protected $root_path;
	protected $phpEx;
	/** @var \phpbb\auth\auth */
	protected $auth;
    /** @var \phpbb\controller\helper */
    protected $controller_helper;
	protected $request;
	protected $config;
	/**
	* Constructor
	*
	* @param \phpbb\controller\helper	$helper		Controller helper object
	* @param \phpbb\template			$template	Template object
	*/
	public function __construct(\phpbb\controller\helper $controller_helper, \phpbb\template\template $template, \phpbb\db\driver\driver_interface $db, \phpbb\user $user, $root_path, $phpEx, \phpbb\auth\auth $auth, \phpbb\request\request $request, \phpbb\config\config $config)	
{
        $this->controller_helper = $controller_helper;
        $this->template = $template;
		$this->db = $db;
		$this->user = $user;
		$this->root_path = $root_path;
		$this->phpEx   = "php";
		$this->auth = $auth;
		$this->request = $request;
		$this->config = $config;
	}

public function acp_data($event)
{
$r = $this->request->variable('forum_smt', 0);
if($r)
{
$forum_id = $event['forum_data']['forum_id'];
$this->config->set('smt_forum', $forum_id);
}
}


public function acp_init($event)
{
if ($event['action'] == 'add')
		{
			$array = $event['forum_data'];
			$array['forum_smt'] = '0'; //pred
			$event['forum_data'] = $array;
		}
}

public function acp_form($event)
{
$array = $event['template_data'];
$conf = $this->config['smt_forum'];
if($conf == $event['forum_id'])
{
		$array['SMT'] = true;
}
$event['template_data'] = $array;
}


	public function permission_wvtt($event)
	{
	$permissions = $event['permissions'];
	$permissions['u_wvtt'] = array('lang' => 'ACL_U_WVTT', 'cat' => 'misc');
	$permissions['u_wvtt_popup'] = array('lang' => 'ACL_U_WVTT_POPUP', 'cat' => 'misc');
	$permissions['u_wvtt_count'] = array('lang' => 'ACL_U_WVTT_COUNT', 'cat' => 'misc');
	$permissions['u_wvtt_profile'] = array('lang' => 'ACL_U_WVTT_PROFILE', 'cat' => 'misc');
	$event['permissions'] = $permissions;
	}
	
	public function load_language_on_setup($event)
	{
		$lang_set_ext = $event['lang_set_ext'];
		$lang_set_ext[] = array(
			'ext_name' => 'bruninoit/smt',
			'lang_set' => 'common',
		);
		$event['lang_set_ext'] = $lang_set_ext;
	}

public function post($event)
{
$rowmessage = $event['post_row'];
$post_id = $rowmessage['POST_ID'];
$forum_id = $event['row']['forum_id'];
$new_forum_id = $this->config['smt_forum'];
if($this->auth->acl_get('m_delete', $forum_id) or $this->auth->acl_get('m_move', $forum_id))
		{
$url_post = append_sid("{$this->root_path}viewtopic.$this->phpEx", "f=$forum_id&amp;p=$post_id&amp;smt_post=1");

if($forum_id != $new_forum_id)
{
$rowmessage['U_SMT_POST'] = $url_post;
}
}
$event['post_row'] = $rowmessage;
}


	public function viewtopic_actions($event)
	{
    $topic_id=$event['topic_id'];
    $user_id=$this->user->data['user_id'];
  $forum_id = $event['forum_id'];
$post_id = $this->request->variable('p', 0);




	if($this->auth->acl_get('m_delete', $forum_id) or $this->auth->acl_get('m_move', $forum_id))
		{
$smt = $this->request->variable('smt', 0);
$smt_post = $this->request->variable('smt_post', 0);
$new_forum_id = $this->config['smt_forum'];

if($smt_post)
{
 include($this->root_path . 'includes/functions_admin.' . $this->phpEx);
//query post
$qp = $this->db->sql_query("SELECT post_subject FROM ". POSTS_TABLE ." WHERE post_id=". $post_id);
$post = $this->db->sql_fetchrow($qp);
$title = $post['post_subject'];
$sql_ary = array(	
'forum_id'			=> $new_forum_id,	
'topic_title'		=> $title,	
'icon_id'			=> 0,	
'topic_visibility'	=> 1
);	
$sql = 'INSERT INTO ' . TOPICS_TABLE . ' ' . $this->db->sql_build_array('INSERT', $sql_ary);
$this->db->sql_query($sql);
$to_topic_id = $this->db->sql_nextid();
move_posts(array($post_id), $to_topic_id);
$url = append_sid("{$this->root_path}viewtopic.$this->phpEx", "f=$forum_id&amp;t=$topic_id");
redirect($url);
}
if($smt)
{
 include($this->root_path . 'includes/functions_admin.' . $this->phpEx);

move_topics(array($topic_id), $new_forum_id);
global $phpbb_log;
$qf = $this->db->sql_query("SELECT forum_name FROM ". FORUMS_TABLE ." WHERE forum_id=". $forum_id);
$forum = $this->db->sql_fetchrow($qf);
$phpbb_log->add('mod', $this->user->data['user_id'], $this->user->ip, 'LOG_MOVE', false, array(	
'forum_id'		=> (int) $new_forum_id,
'topic_id'		=> (int) $topic_id,
$forum['forum_name'],
"staff",
(int) $forum_id,
(int) $new_forum_id,
));
$url = append_sid("{$this->root_path}viewtopic.$this->phpEx", "f=$forum_id&amp;t=$topic_id");
redirect($url);
}

$url = append_sid("{$this->root_path}viewtopic.$this->phpEx", "f=$forum_id&amp;t=$topic_id&amp;smt=1");
if($forum_id != $new_forum_id)
$this->template->assign_var('U_SMT', $url);
		}


 
    }
}

